#include <stdlib.h>
#include <memory.h>

#include "random.h"

// (_)
int RandomMove( struct game *game, int color)
{
	int *rate = game->candidates;
	int *sum_rate_column = game->sum_candidates_column;
	int *sum_rate = &game->sum_candidates;
	int y, pos;
	int rand_num;
	
	while( 1 ){
		if(*sum_rate == 0) return PASS;

		rand_num = (rand() % (*sum_rate)) + 1;

		y = BOARD_START;
		while( rand_num > sum_rate_column[y] ) rand_num -= sum_rate_column[y++];

		pos = POS(BOARD_START, y);

		do{
			rand_num -= rate[pos];
			if(rand_num <= 0) break;
			pos++;
		}while( 1 );

		if( CheckLegalAndEye( game, color, pos ) == TRUE ) break;

		rate[pos] = 0;
		(*sum_rate)--;
		sum_rate_column[board_y[pos]]--;
	}

	return pos;
}